// --------------------------------------------------------------------------
//
// NAME                    : Feedback
// VERSION                 : 1.1 
// COMPILED USING          : SUN JDK 1.1 / KAWA IDE
// AUTHOR                  : Dan Page (dan@hnet.demon.co.uk)
// LAST REVISION DATE      : 12th October 1996 
// NOTES                   : This is a simple CGI type feedback form.
//
// --------------------------------------------------------------------------

// -----------------------------------------
// Declare we are part of the right package.
// -----------------------------------------
package uk.co.demon.hnet.applets;

// --------------------------------------------------------------------------
// Import all the super duper java class files.
// --------------------------------------------------------------------------
import java.awt.*;
import java.applet.*;
import java.io.*;
import uk.co.demon.hnet.awt.*;
import uk.co.demon.hnet.net.*;
 
// --------------------------------------------------------------------------
// Define the main class.
// --------------------------------------------------------------------------
public class Feedback extends Applet
{

	// -------------------------
	// Define private variables.
	// -------------------------
	private TextField name        			= null;
	private TextField email       			= null;
	private TextField productName			= null;
	private TextField productVersion 	= null;
	private Choice    platformName    	= null;
	private Choice    browserName     	= null;
	private Choice    jdkVersion				= null;
	private TextArea  bugs   					= null;
	private TextArea  comments    			= null;

	private String    emailTo     			= "";
	private String    emailFrom   			= "";
	private String    emailHost   			= "";
	private String    emailSubj   			= "";
	
	// --------------------------------------------------
	// Define a default constructor to set up the applet.
	// --------------------------------------------------
	public void init()
	{
	
		// Make the GUI.
		makeGUI();
	
		// Call the clearForm method to set up fields.
		clearForm();
		
		// Debug the applet if we need to.
		if( getParameter( "debug" ) != null ) { debugApplet(); }
	
	}
	
	// -----------------------------------  
  // Define a method to debug the setup.
  // -----------------------------------
  private void debugApplet()
  {
  
  	// Output indicators to tell about internal stats.
  	System.out.println( "emailTo    = " + emailTo );
   	System.out.println( "emailFrom  = " + emailFrom );
  	System.out.println( "emailHost  = " + emailHost );
  	System.out.println( "emailSubj  = " + emailSubj );

  }

	// -------------------------------------------	
	// Define a method to tell the world about us.
	// -------------------------------------------
	public String getAppletInfo() 
	{ 
	
		// Return a boasting string.
		return "Feedback Applet by Dan Page / hairNET  [http://www.hnet.demon.co.uk]"; 
		
	}

	// -----------------------------------------------	
	// Define a method to make the GUI for the applet.
	// -----------------------------------------------
	private void makeGUI()
	{
	
		// Define local variables.
		Button button 			= null;
		Label label 				= null;
		
		// Make the layout managers.
		FixedGridLayout layout = new FixedGridLayout( 2, 15 );
		setLayout( layout );
		
		// Make the name, email and product detail text fields.
		name 						= new TextField( "", 20 );
		email 					= new TextField( "", 20 );
		productName 		= new TextField( "", 20 );
		productVersion 	= new TextField( "", 20 );
			
		// Make the platform choice.
		platformName = new Choice();
		platformName.addItem( "Windows 95" );
		platformName.addItem( "Windows NT" );
		platformName.addItem( "Windows 3.x" );
		platformName.addItem( "Solaris" );
		platformName.addItem( "Linux" );
		platformName.addItem( "Other UNIX" );
		platformName.addItem( "Mac" );
		platformName.addItem( "Other" );
		
		// Make the browser choice.
		browserName = new Choice();
		browserName.addItem( "Netscape 2.x" );
		browserName.addItem( "Netscape 3.x" );
		browserName.addItem( "Netscape 4.x" );
		browserName.addItem( "Internet Explorer 2.x" );
		browserName.addItem( "Internet Explorer 3.x" );
		browserName.addItem( "Internet Explorer 4.x" );
		browserName.addItem( "HotJava 1.x" );
		browserName.addItem( "Other" );
		
		// Make the JDK version choice.
		jdkVersion = new Choice();
		jdkVersion.addItem( "1.0.0" );
		jdkVersion.addItem( "1.0.1" );
		jdkVersion.addItem( "1.0.2" );
		jdkVersion.addItem( "1.1.0" );
		jdkVersion.addItem( "1.1.1" );
		jdkVersion.addItem( "1.1.2" );
		jdkVersion.addItem( "1.1.3" );
		jdkVersion.addItem( "1.1.4" );
	
		// Make the bugs and comments text areas.
		bugs 			= new TextArea( "", 5, 20, TextArea.SCROLLBARS_VERTICAL_ONLY );
		comments 	= new TextArea( "", 5, 20, TextArea.SCROLLBARS_VERTICAL_ONLY );
			
		// Position all the components on applet.
		label = new Label( "Name" );
		layout.setConstraints( label, makeFixedGridCons( 0, 0, 1, 1 ) );
		layout.setConstraints( name, makeFixedGridCons( 1, 0, 1, 1 ) );
		add( label );
		add( name );
		
		label = new Label( "EMail" );
		layout.setConstraints( label, makeFixedGridCons( 0, 1, 1, 1 ) );
		layout.setConstraints( email, makeFixedGridCons( 1, 1, 1, 1 ) );
		add( label );
		add( email );
		
		label = new Label( "Product Name" );
		layout.setConstraints( label, makeFixedGridCons( 0, 2, 1, 1 ) );
		layout.setConstraints( productName, makeFixedGridCons( 1, 2, 1, 1 ) );
		add( label );
		add( productName );
		
		label = new Label( "Product Version" );
		layout.setConstraints( label, makeFixedGridCons( 0, 3, 1, 1 ) );
		layout.setConstraints( productVersion, makeFixedGridCons( 1, 3, 1, 1 ) );
		add( label );
		add( productVersion );
		
		label = new Label( "Platform" );
		layout.setConstraints( label, makeFixedGridCons( 0, 4, 1, 1 ) );
		layout.setConstraints( platformName, makeFixedGridCons( 1, 4, 1, 1 ) );
		add( label );
		add( platformName );
		
		label = new Label( "Browser" );
		layout.setConstraints( label, makeFixedGridCons( 0, 5, 1, 1 ) );
		layout.setConstraints( browserName, makeFixedGridCons( 1, 5, 1, 1 ) );
		add( label );
		add( browserName );
		
		label = new Label( "JDK Version" );
		layout.setConstraints( label, makeFixedGridCons( 0, 6, 1, 1 ) );
		layout.setConstraints( jdkVersion, makeFixedGridCons( 1, 6, 1, 1 ) );
		add( label );
		add( jdkVersion );
		
		label = new Label( "Bug Report" );
		layout.setConstraints( label, makeFixedGridCons( 0, 8, 1, 1 ) );
		layout.setConstraints( bugs, makeFixedGridCons( 1, 7, 1, 3 ) );
		add( label );
		add( bugs );
		
		label = new Label( "Other Comments" );
		layout.setConstraints( label, makeFixedGridCons( 0, 11, 1, 1 ) );
		layout.setConstraints( comments, makeFixedGridCons( 1, 10, 1, 3 ) );
		add( label );
		add( comments );
		
		button = new Button( "Send Data" );
		layout.setConstraints( button, makeFixedGridCons( 0, 14, 1, 1 ) );
		add( button );
		button = new Button( "Clear Form" );
		layout.setConstraints( button, makeFixedGridCons( 1, 14, 1, 1 ) );
		add( button );
		
	}
	
	// -----------------------------------------------
	// Define a 'make FixedGrid constraints' method.
 	// -----------------------------------------------
	private FixedGridConstraints makeFixedGridCons( int x, int y, int dx, int dy )
	{

		// Define local variables.
		FixedGridConstraints cons = new FixedGridConstraints();

		// Set the constraints.
		cons.gridX      = x;
		cons.gridY      = y;
		cons.gridWidth  = dx;
		cons.gridHeight = dy;

		// Return the constraints to the caller.
		return cons;

	}

	// ----------------------------------------------------
	// Define an action method to deal with button presses.
	// ----------------------------------------------------
	public boolean action( Event evt, Object arg )
	{
	
		// Check we are dealing with a button press.
		if( arg instanceof String )
		{
			if     ( arg == "Send Data"  ) { sendForm();  }
			else if( arg == "Clear Form" ) { clearForm(); }
		}
		
		// Handled event - return such.
		return true;
		
	}	
	
	// -----------------------------------------------------
	// Define a method to send the form to whoever wants it.
	// -----------------------------------------------------
	private void sendForm()
	{
	
		// Define local variables.
		StringWriter outString    = new StringWriter();
		PrintWriter outStream     = new PrintWriter( outString, true );
		SMTPMailClient mailClient = null;

		// Tell world we are prepairing to send email
		getAppletContext().showStatus( "Preparing to send feedback." );
		
		// Write all the details to the the string.
		outStream.println( "" );
		outStream.println( "DETAILS" );
		outStream.println( "-------" );
		outStream.println( "" );
		outStream.println( "NAME            : " + name.getText() );
		outStream.println( "EMAIL           : " + email.getText() );
		outStream.println( "PRODUCT NAME    : " + productName.getText() );
		outStream.println( "PRODUCT VERSION : " + productVersion.getText() );
		outStream.println( "PLATFORM NAME   : " + platformName.getSelectedItem() );
		outStream.println( "BROWSER NAME    : " + browserName.getSelectedItem() );
		outStream.println( "JDK VERSION     : " + jdkVersion.getSelectedItem() );
		outStream.println( "" );
		outStream.println( "" );
		outStream.println( "BUG REPORT" );
		outStream.println( "----------" );
		outStream.println( "" );
		outStream.println( bugs.getText() );
		outStream.println( "" );
		outStream.println( "COMMENTS" );
		outStream.println( "--------" );
		outStream.println( "" );
		outStream.println( comments.getText() );
		
		// Try and send the email.
		try
		{
		
			// Open connection to the email host.
			getAppletContext().showStatus( "Opening port to mail host." );
			mailClient = new SMTPMailClient( emailHost, 25 );
			
			// Send the mail.
			getAppletContext().showStatus( "Sending feedback....." );
			mailClient.sendMail( emailTo, emailFrom, emailSubj, outString.toString() );
			
			// Tell world sending was success.
			getAppletContext().showStatus( "Feedback was sent successfully." );
			
		}
		catch( Exception e ) { getAppletContext().showStatus( "Error sending feedback : " + e.toString() ); }
			
	}

	// ----------------------------------
	// Define a method to clear the form.
	// ----------------------------------
	private void clearForm()
	{
	
		// Tell world we are clearing.
		getAppletContext().showStatus( "Clearing the form." );   
	
		// Clear name and email.
		name.setText( "" );
		email.setText( "" );
	
		// Reset the browser etc.
		platformName.select( "Windows 95" );
		browserName.select( "Internet Explorer 3.x" );	
		jdkVersion.select( "1.1.4" );
					
		// Get the parameters into the email address etc.
		if( getParameter( "emailTo" ) != null ) 				{ emailTo = getParameter( "emailTo" ); }
		else                                    				{ emailTo = ""; }
		if( getParameter( "emailFrom" ) != null ) 			{ emailFrom = getParameter( "emailFrom" ); }
		else                                    				{ emailFrom = ""; }
		if( getParameter( "emailSubject" ) != null ) 		{ emailSubj = getParameter( "emailSubject" ); }
		else                                    				{ emailSubj = ""; }
		if( getParameter( "emailHost" ) != null ) 			{ emailHost = getParameter( "emailHost" ); }
		else                                    				{ emailHost = ""; }
		if( getParameter( "productName" ) != null )			{ productName.setText( getParameter( "productName" ) ); }
		if( getParameter( "productVersion" ) != null )	{ productVersion.setText( getParameter( "productVersion" ) ); }
		
		// Tell world we have finished.
		getAppletContext().showStatus( "The form was cleared successfully." );   
	
	}
	
}