// --------------------------------------------------------------------------
//
// NAME                    : ScrollerLineData.java
// VERSION                 : 1.0 
// COMPILED USING          : SUN JDK 1.1.2 / KAWA IDE 2.5 
// AUTHOR                  : Dan Page (dan@hnet.demon.co.uk)
// LAST REVISION DATE      :  
// NOTES                   : 
//
// --------------------------------------------------------------------------

// -----------------------------------------
// Declare we are part of the right package.
// -----------------------------------------
package uk.co.demon.hnet.applets;

// --------------------------------------------------------------------------
// Import all the super duper java class files.
// --------------------------------------------------------------------------
import java.awt.*;
import java.net.*;
 
// --------------------------------------------------------------------------
// Define the main class.
// --------------------------------------------------------------------------
public class ScrollerLineData
{

	// --------------------------------
  // Define private member variables.
  // --------------------------------
  private String lineText					= null;
  private Color lineForeground		= null;
  private Color lineBackground		= null;
  private Image lineImage					= null;
  private URL lineLink						= null;
  private int lineJustification		= 0;
  
	// -------------------------------
  // Define public member variables.
  // -------------------------------
  public static final int LEFT		= 0;
  public static final int RIGHT		= 1;
  public static final int CENTER	= 2;

  // -----------------------------------------
  // Define a constructor to set up the class.
  // -----------------------------------------
	public ScrollerLineData( String text, String link )
	{
		// Create member variables.
		lineText = new String( text );
		setLink( link );
	}
	
  // -----------------------------------------
  // Define a constructor to set up the class.
  // -----------------------------------------
	public ScrollerLineData( String text, Color foreground, int justification )
	{
		// Create member variables.
		lineText 					= new String( text );
		lineForeground 		= foreground;
		lineJustification = justification;	
	}
	
  // -----------------------------------------
  // Define a constructor to set up the class.
  // -----------------------------------------
	public ScrollerLineData( String text, Color foreground, String link )
	{
		// Create member variables.
		lineText 					= new String( text );
		lineForeground 		= foreground;
		setLink( link );	
	}

	// ---------------------------------------	
	// Define methods to get member variables.
	// ---------------------------------------
	public String getText() { return lineText; }
	public URL getLink() { return lineLink; }
	public Image getImage() { return lineImage; }
	public Color getForeground() { return lineForeground; }
	public Color getBackground() { return lineBackground; }
	public int getJustification() { return lineJustification; }

	// ---------------------------------------	
	// Define methods to set member variables.
	// ---------------------------------------
	public void setText( String s ) { lineText = new String( s ); } 
	public void setLink( URL u ) { lineLink = u; }
	public void setLink( String s ) { try { setLink( new URL( s ) ); } catch( MalformedURLException e ) { lineLink = null; } }
	public void setImage( Image i ) { lineImage = i; }
	public void setForeground( Color c ) { lineForeground = c; }
	public void setBackground( Color c ) { lineBackground = c; }
	public void setJustification( int i ) { lineJustification = i; }

}

 