// ------------------------------------------------------------
//
// NAME                    : zoomText.java
// VERSION                 :  
// COMPILED USING          : SUN JDK 1.1.6
// AUTHOR                  : Matthew law (mtl96c@cs.nott.ac.uk)
// LAST REVISION DATE      : 10th May 1998
// NOTES                   : 
//
// ------------------------------------------------------------

package uk.co.demon.hnet.applets;

// -------------------------------------
// import all the relevant java class'es
// -------------------------------------
import java.awt.*;
import java.applet.Applet;
import java.applet.AppletContext;
import java.util.*;

public class zoomImage extends Applet implements Runnable
{

    private Thread zooming      = null;
    private Image[] images      = null;
    private Color bgColor       = null;
    private Image offImage      = null;
    private Graphics offSrc     = null;
    private int zoomPercent     = 0;
    private int dZoom           = 1;
    private int speed           = 10;
    private int numImages       = 0;
    private int currentImage    = 0;

    public zoomImage() {}

    public void start()
    {
        if( zooming != null ) { zooming.start(); }
    }

    public void stop()
    {
        if( zooming != null ) { zooming.stop(); }
    }

    public void run()
    {

        for(;;)
        {
            try{ Thread.sleep( speed ); }
            catch( InterruptedException e ) {}

            repaint();

            zoomPercent += dZoom;

            if( zoomPercent <= 0 )
            {
                dZoom *= -1;
                currentImage++;
                if( currentImage >= numImages )
                {
                    currentImage    = 0;
                }
            }

            if( zoomPercent >= 100 )
            {
                dZoom *= -1;
            }
        }
    }

	// ------------------
	// return applet info
	// ------------------
	public String getAppletInfo()
	{
		return "zoomImage Mattlet v1 - Matt Law of Javarama, www.hnet.demon.co.uk";
	}

    // ------------------------------------------------
    // Define a method to parse a hex string for colour
    // ------------------------------------------------
	private Color parseColorString(String colourString)
	{

		// if the string is not 6 characters ie numbers then set to black
		if (colourString.length() != 6)
			return Color.black;

		int red   = Integer.valueOf(colourString.substring(0, 2), 16).intValue(); // get red
		int green = Integer.valueOf(colourString.substring(2, 4), 16).intValue(); // get green
		int blue  = Integer.valueOf(colourString.substring(4, 6), 16).intValue(); // get blue

		return new Color(red, green, blue); // return the colour

	} // end parseColorString()

    public void init()
    {
        String param        = null;
        int num             = 0;
        boolean moreImages  = true;
        Image tempImage     = null;
        Vector imageVec     = new Vector( 10, 1 );

        if ( (param = getParameter( "bgcolor" ) ) == null )
		{
            bgColor = Color.black;
		}
		else
		{
			bgColor = parseColorString( param );
		}

        if ( (param = getParameter( "zoomsteps" ) ) == null )
		{
            dZoom   = 1;
		}
		else
		{
            try
            {
                dZoom   = Integer.parseInt( param );
            }
            catch( NumberFormatException e )
            {
                dZoom   = 1;
            }
		}

        if ( (param = getParameter( "speed" ) ) == null )
		{
            speed   = 100;
		}
		else
		{
            try
            {
                speed   = Integer.parseInt( param );
            }
            catch( NumberFormatException e )
            {
                speed   = 100;
            }
		}

         // loop while we can read in more images
        while( moreImages )
        {

            // get the next image
            param = getParameter( "image" + num );

            // if its null, no more images
            if( param == null )
            {
                // set the loop flag
                moreImages = false;

                // create the image array
                images = new Image[ imageVec.size() ];

                // set the numImages variables
                numImages = images.length;

                // copy the images into the array
                imageVec.copyInto( images );

                offImage = createImage( size().width, size().height );
                offSrc   = offImage.getGraphics();

                // and GO!
                if( numImages != 0 ) { zooming = new Thread( this ); }

            }
            else
            {
                showStatus( "Loading " + param );
                // load the image
                tempImage = getImage( getDocumentBase(), param );
                forceLoadImage( tempImage );

                // put the image into the vector
                imageVec.addElement( tempImage );

                // and increment the counter
                num++;
            }
        }

    }

    public void update( Graphics g )
    {
        offSrc.setColor( Color.black );
        offSrc.fillRect( 0, 0, size().width, size().height );

        int sWidth  = (int)( ( size().width / 100f ) * (float)zoomPercent );
        int sHeight = (int)( ( size().height / 100f ) * (float)zoomPercent );

        int xInset  = ( size().width - sWidth ) / 2;
        int yInset  = ( size().height - sHeight ) / 2;

        offSrc.drawImage( images[ currentImage ], xInset, yInset, sWidth, sHeight, this );

        g.drawImage( offImage, 0, 0, this );
    }

    // --------------------------------------------
    // define the method that uses the mediatracker
    // --------------------------------------------
    private synchronized void forceLoadImage( Image image ) 
	{
	
		// Define local variables.
		MediaTracker tracker = new MediaTracker( this );
	
		// Make sure we aren't loading a null image.
        if ( image != null ) 
        {
        	// Add the image and wait for it to load.
        	tracker.addImage( image, 0 );
         	try { tracker.waitForID( 0 ); } catch( Exception e ) { image = null; }
        }
	}
}