// --------------------------------------------------------------------------
//
// NAME                    : FindEdgesImageFilter.java
// VERSION                 :  
// COMPILED USING          : SUN JDK 1.1.2 / KAWA IDE 2.5
// AUTHOR                  : Dan Page (dan@hnet.demon.co.uk)
// LAST REVISION DATE      :  
// NOTES                   : 
//
// --------------------------------------------------------------------------

// -----------------------------------------
// Declare we are part of the right package.
// -----------------------------------------
package uk.co.demon.hnet.awt.image;

// --------------------------------------------------------------------------
// Import all the super duper java class files.
// --------------------------------------------------------------------------
import java.awt.*;
import java.awt.image.*;
 
// --------------------------------------------------------------------------
// Define the main class.
// --------------------------------------------------------------------------
public class FindEdgesImageFilter extends ImageFilter
{

  // -------------------------------------------------------  
  // Define a method that filters an entire image of pixels.
  // -------------------------------------------------------
  public void setPixels(int x, int y, int w, int h, ColorModel model, byte pixels[], int off, int scansize)
  {
  
    // Define local variables.  
    byte[] tempPixels;
    int xCounter, yCounter, offset;  
    int rgb, rgb1, rgb2, rgb3, rgb4, rgb5, rgb6, rgb7, rgb8;
    int a;
    int r, r1, r2, r3, r4, r5, r6, r7, r8;
    int rsum, rsum1, rsum2;

    // Create a new place to store pixels.
    tempPixels = new byte[ w * h ];
    
    // Copy the pixels from the original array to a temporary holding place.
		for( xCounter = 0; xCounter < w * h; xCounter++ ) { tempPixels[ xCounter ] = pixels[ xCounter ]; }
		
    for( yCounter = 1; yCounter < ( h - 1 ); yCounter++ ) 
    {
		
    	for( xCounter = 1; xCounter < ( w - 1 ); xCounter++ ) 
      {
				
        offset = xCounter + yCounter * w;
				 
         
         rgb = tempPixels[offset];
        			a = rgb & 0xff000000;
					r = (rgb & 0x00ff0000) >> 16;
				rgb1 = tempPixels[offset - w - 1];
					r1 = (rgb1 & 0x00ff0000) >> 16;
				rgb2 = tempPixels[offset - w];
					r2 = (rgb2 & 0x00ff0000) >> 16;
				rgb3 = tempPixels[offset - w + 1];
					r3 = (rgb3 & 0x00ff0000) >> 16;
				rgb4 = tempPixels[offset + 1];
					r4 = (rgb4 & 0x00ff0000) >> 16;
				rgb5 = tempPixels[offset + w + 1];
					r5 = (rgb5 & 0x00ff0000) >> 16;
				rgb6 = tempPixels[offset + w];
					r6 = (rgb6 & 0x00ff0000) >> 16;
				rgb7 = tempPixels[offset + w - 1];
					r7 = (rgb7 & 0x00ff0000) >> 16;
				rgb8 = tempPixels[offset - 1];
					r8 = (rgb8 & 0x00ff0000) >> 16;
	        		
	      rsum1 = r1 + 2*r2 + r3 - r5 -2*r6 - r7;
	      rsum2 = r1 - r3 - 2*r4 -r5 + r7 + 2*r8;
	      rsum = ( int )( Math.sqrt( rsum1*rsum1 + rsum2*rsum2 ) );
	      if (rsum> 255) { rsum = 255; }

				pixels[offset] = ( byte )( a | (rsum << 16) | (rsum << 8) | rsum );

			}
		
		}

    // Call the consumer set pixels method.
    consumer.setPixels( x, y, w, h, model, pixels, off, scansize );
    
  }
  
}

 