// --------------------------------------------------------------------------
//
// NAME                    : FlipHorizontalImageFilter.java
// VERSION                 :  
// COMPILED USING          : SUN JDK 1.1.2 / KAWA IDE 2.5
// AUTHOR                  : Dan Page (dan@hnet.demon.co.uk)
// LAST REVISION DATE      :  
// NOTES                   : 
//
// --------------------------------------------------------------------------

// -----------------------------------------
// Declare we are part of the right package.
// -----------------------------------------
package uk.co.demon.hnet.awt.image;

// --------------------------------------------------------------------------
// Import all the super duper java class files.
// --------------------------------------------------------------------------
import java.awt.*;
import java.awt.image.*;
 
// --------------------------------------------------------------------------
// Define the main class.
// --------------------------------------------------------------------------
public class FlipHorizontalImageFilter extends ImageFilter
{

  // -------------------------------------------------------  
  // Define a method that filters an entire image of pixels.
  // -------------------------------------------------------
  public void setPixels(int x, int y, int w, int h, ColorModel model, byte pixels[], int off, int scansize)
  {
  
    // Define local variables.
    byte[] tempPixels;
    int xCounter, yCounter, offset, destOffset;
    
    // Create a new place to store pixels.
    tempPixels = new byte[ w * h ];
    
    // Filter the pixels along the y axis.    
    for( yCounter = 0; yCounter < h; yCounter++ ) 
    {
    
      // Filter the pixels along a scan line.
		  for( xCounter = 0; xCounter < w; xCounter++ ) 
      {
      
        // Calcualte the offset within the array.
        offset = xCounter + ( yCounter * w );
        
				// Calculate the destination offset.
				destOffset = ( w - 1 - xCounter ) + ( yCounter * w );

        // Set the pixel.
        tempPixels[ destOffset ] = pixels[ offset ];
        
	    }

    }
    
    // Call the consumer set pixels method.
    consumer.setPixels( x, y, w, h, model, tempPixels, off, scansize );
    
  }
  
}

 