// --------------------------------------------------------------------------
//
// NAME                    : GrayScaleImageFilter.java
// VERSION                 :  
// COMPILED USING          : SUN JDK 1.1.2 / KAWA IDE 2.5
// AUTHOR                  : Dan Page (dan@hnet.demon.co.uk)
// LAST REVISION DATE      :  
// NOTES                   : 
//
// --------------------------------------------------------------------------

// -----------------------------------------
// Declare we are part of the right package.
// -----------------------------------------
package uk.co.demon.hnet.awt.image;

// --------------------------------------------------------------------------
// Import all the super duper java class files.
// --------------------------------------------------------------------------
import java.awt.*;
import java.awt.image.*;
 
// --------------------------------------------------------------------------
// Define the main class.
// --------------------------------------------------------------------------
public class GrayScaleImageFilter extends RGBImageFilter
{

	// ----------------------------------
	// Define a contructor for the class.
	// ----------------------------------
	public GrayScaleImageFilter() { canFilterIndexColorModel = true; }
	
	// ----------------------------------------
	// Define a method used to filter an image.
	// ----------------------------------------
	public int filterRGB( int x, int y, int rgb )
	{
  
    // Define local variables.
    int red   = ( rgb & 0xff0000 ) >> 16;
    int green = ( rgb & 0x00ff00 ) >> 8;
    int blue  = ( rgb & 0x0000ff ) >> 0;  
    int gray  = ( ( red * 3 ) + ( green * 4 ) + ( blue * 2 ) ) / 9;  
    
    // Return the gray'ed version.
	  return ( rgb & 0xff000000 ) + ( gray << 16 ) + ( gray << 8 ) + gray;
  
	}
	
}

 