// --------------------------------------------------------------------------
//
// NAME                    : NegativeImageFilter.java
// VERSION                 :  
// COMPILED USING          : SUN JDK 1.1.2 / KAWA IDE 2.5
// AUTHOR                  : Dan Page (dan@hnet.demon.co.uk)
// LAST REVISION DATE      :  
// NOTES                   : 
//
// --------------------------------------------------------------------------

// -----------------------------------------
// Declare we are part of the right package.
// -----------------------------------------
package uk.co.demon.hnet.awt.image;

// --------------------------------------------------------------------------
// Import all the super duper java class files.
// --------------------------------------------------------------------------
import java.awt.*;
import java.awt.image.*;
 
// --------------------------------------------------------------------------
// Define the main class.
// --------------------------------------------------------------------------
public class NegativeImageFilter extends RGBImageFilter
{

	// ----------------------------------
	// Define a contructor for the class.
	// ----------------------------------
	public NegativeImageFilter() { canFilterIndexColorModel = true; }
	
	// ----------------------------------------
	// Define a method used to filter an image.
	// ----------------------------------------
	public int filterRGB( int x, int y, int rgb )
	{
  
    // Define local variables.
    int red   = ( rgb & 0xff0000 ) >> 16;
    int green = ( rgb & 0x00ff00 ) >> 8;
    int blue  = ( rgb & 0x0000ff ) >> 0;  
    
    // Negate the colors.
    red   = 255 - red;
    green = 255 - green;
    blue  = 255 - blue;
    
    // Return the negative version.
	  return ( rgb & 0xff000000 ) + ( red << 16 ) + ( green << 8 ) + blue;
  
	}
	
}

 