// --------------------------------------------------------------------------
//
// NAME                    : NoiseImageFilter.java
// VERSION                 :  
// COMPILED USING          : SUN JDK 1.1.2 / KAWA IDE 2.5
// AUTHOR                  : Dan Page (dan@hnet.demon.co.uk)
// LAST REVISION DATE      :  
// NOTES                   : 
//
// --------------------------------------------------------------------------

// -----------------------------------------
// Declare we are part of the right package.
// -----------------------------------------
package uk.co.demon.hnet.awt.image;

// --------------------------------------------------------------------------
// Import all the super duper java class files.
// --------------------------------------------------------------------------
import java.awt.*;
import java.awt.image.*;
import java.util.*;
 
// --------------------------------------------------------------------------
// Define the main class.
// --------------------------------------------------------------------------
public class NoiseImageFilter extends RGBImageFilter
{

  // --------------------------------
  // Define private member variables.
  // --------------------------------
  private int noiseFactor        = 0;
  private Random randomGenerator = null;
 
	// ----------------------------------
	// Define a contructor for the class.
	// ----------------------------------
	public NoiseImageFilter( int i ) 
  { 
  
    // Create member variables.
    canFilterIndexColorModel = true; 
    noiseFactor              = i;
    randomGenerator          = new Random();
    
  }
	
	// ----------------------------------------
	// Define a method used to filter an image.
	// ----------------------------------------
	public int filterRGB( int x, int y, int rgb )
	{
  
    // Define local variables.
    int red         = ( rgb & 0xff0000 ) >> 16;
    int green       = ( rgb & 0x00ff00 ) >> 8;
    int blue        = ( rgb & 0x0000ff ) >> 0;  
    int randomNoise = ( int )( randomGenerator.nextGaussian() * noiseFactor );
    
    // Shift the rgb values by random amount. 
    green += randomNoise;
	  if( green < 0 )   { green = 0;   }
    if( green > 255 ) { green = 255; }

    blue += randomNoise;
	  if( blue < 0 )   { blue = 0;   }
    if( blue > 255 ) { blue = 255; }


		// Return the deformed noisy version.
	  return ( rgb & 0xff000000 ) + ( red << 16 ) + ( green << 8 ) + blue;
  
	}
	
}

 