// --------------------------------------------------------------------------
//
// NAME                    : SoftenImageFilter.java
// VERSION                 :  
// COMPILED USING          : SUN JDK 1.1.2 / KAWA IDE 2.5
// AUTHOR                  : Dan Page (dan@hnet.demon.co.uk)
// LAST REVISION DATE      :  
// NOTES                   : 
//
// --------------------------------------------------------------------------

// -----------------------------------------
// Declare we are part of the right package.
// -----------------------------------------
package uk.co.demon.hnet.awt.image;

// --------------------------------------------------------------------------
// Import all the super duper java class files.
// --------------------------------------------------------------------------
import java.awt.*;
import java.awt.image.*;
 
// --------------------------------------------------------------------------
// Define the main class.
// --------------------------------------------------------------------------
public class SoftenImageFilter extends ImageFilter
{

  // -------------------------------------------------------  
  // Define a method that filters an entire image of pixels.
  // -------------------------------------------------------
  public void setPixels(int x, int y, int w, int h, ColorModel model, byte pixels[], int off, int scansize)
  {
  
    // Define local variables.
    byte[] tempPixels;
    int rgb, rgb1, rgb2, rgb3, rgb4, rgb5, rgb6, rgb7, rgb8, rgbMean;
    int redSum = 0, greenSum = 0, blueSum = 0;
    int xCounter, yCounter, offset;
    
    // Create a new place to store pixels.
    tempPixels = new byte[ w * h ];
    
    // Copy the pixels from the original array to a temporary holding place.
		for( xCounter = 0; xCounter < w * h; xCounter++ ) { tempPixels[ xCounter ] = pixels[ xCounter ]; }
		
    // Filter the pixels along the y axis.    
    for( yCounter = 1; yCounter < ( h - 1 ); yCounter++ ) 
    {
    
      // Filter the pixels along a scan line.
		  for( xCounter = 1; xCounter < ( w - 1 ); xCounter++ ) 
      {
      
        // Calcualte the offset within the array.
        offset = xCounter + ( yCounter * w );
        
        // Find the surrounding pixels.
        rgb1 = tempPixels[ offset - w - 1 ];
        rgb2 = tempPixels[ offset - w ];
        rgb3 = tempPixels[ offset - w + 1 ];
        rgb4 = tempPixels[ offset + 1 ];
	      rgb5 = tempPixels[ offset + w + 1 ];
        rgb6 = tempPixels[ offset + w ];
        rgb7 = tempPixels[ offset + w - 1 ];
	      rgb8 = tempPixels[ offset - 1 ];
	      rgb  = tempPixels[ offset ];
				
        // Calculate the sums of the surrounding pixels.
        redSum   = ( rgb1 & 0xff0000 ) + ( rgb2 & 0xff0000 ) + ( rgb3 & 0xff0000 ) + ( rgb4 & 0xff0000 ) + ( rgb5 & 0xff0000 ) + ( rgb6 & 0xff0000 ) + ( rgb7 & 0xff0000 ) + ( rgb8 & 0xff0000) + ( rgb & 0xff0000 );
	      greenSum = ( rgb1 & 0xff00 ) + ( rgb2 & 0xff00 ) + ( rgb3 & 0xff00 ) + ( rgb4 & 0xff00 ) + ( rgb5 & 0xff00 ) + ( rgb6 & 0xff00) + ( rgb7 & 0xff00 ) + ( rgb8 & 0xff00 ) + ( rgb & 0xff00 );
	      blueSum  = ( rgb1 & 0xff ) + ( rgb2 & 0xff ) + ( rgb3 & 0xff ) + ( rgb4 & 0xff ) + ( rgb5 & 0xff ) + ( rgb6 & 0xff ) + ( rgb7 & 0xff ) + ( rgb8 & 0xff ) + ( rgb & 0xff );
	      rgbMean  = ( ( redSum / 9 ) & 0xff0000 ) | ( ( greenSum / 9 ) & 0xff00 ) | ( blueSum / 9 );
				
        // Set the pixel.
        pixels[ offset ] = ( byte )( ( rgb & 0xff000000 ) | ( rgbMean & 0xffffff ) );
        
	    }

    }
    
    // Call the consumer set pixels method.
    consumer.setPixels( x, y, w, h, model, pixels, off, scansize );
    
  }
  
}

 