#!/bin/sh

# NOTE : This is an EXAMPLE of how to run Lava from anywhere. It needs
#        to be altered to suit your machine. If you don't get it, run 
#        Lava by changing directory to where you installed Lava and 
#        issue the command java Lava

# The LAVAHOME environment variable is a pointer to the directory that
# Lava is installed in. Setting it to point at this directory enables
# Lava to find components such as images and the ini file. If you
# set this to suit your machine and then you can use this batch file to
# run Lava from anywhere.

LAVAHOME="<<insert the path to the lava installation directory here>>"

# We must make sure that the Lava zip is included in the classpath.
# If you already to this, eg. in ~/.tcshrc or /etc/csh.cshrc, you don't
# have to do this.

CLASSPATH="${CLASSPATH}:${LAVAHOME}/lava.jar"

# Export the variables so all shells can see them.

export LAVAHOME CLASSPATH

# We are now ready to run Lava and as all the environments are set up
# correctly, we can just issue the command with a -D flag to put the
# lavahome variable into the system properties.

# Note the change in packaging, needed to enable Lava to integrate with
# other projects and not pollute the name space.  You now need to run
# the class named lava.Lava.

java -Dlava.home=${LAVAHOME} uk.co.demon.hnet.lava.Lava
